/* This code generates a block of random bytes for inclusion into the
 * obcode library as sliding code blocks.
 *
 * Possible improvement is to generate blocks which are more
 * resembling normal code.
 *
 * This program is covered by GNU Public License (unlike the library code).
 *
 * $Id: rnd.c,v 1.2 2002/12/16 21:00:44 kravietz Exp $
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>

int main(void) {
	int i;
	int num;
	unsigned int seed;
	union {
		int i;
		unsigned char c[sizeof(int)];
	} b;

	i = open("/dev/urandom", O_RDONLY);
	if(i > 0) {
		read(i, &seed, sizeof(seed));
		close(i);
	}
	seed ^= time(NULL)^getpid();
	srand(seed);
	do {
		num = rand() % 15;
	} while(num < 7);
	printf("\"\\n\"\n");
	for(i=0; i<num; i++) {
		b.i = rand();
		printf("\"\t.byte 0x%02x\\n\"\n", b.c[sizeof(int)-1]);
	}
	return 0;
}
